"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.clearAll = clearAll;
exports.clearSome = clearSome;
exports.hasWrapper = hasWrapper;
exports.run = run;
exports.setFlags = setFlags;

function _regenerator() {
  var data = _interopRequireDefault(require("@babel/runtime/regenerator"));

  _regenerator = function _regenerator() {
    return data;
  };

  return data;
}

function _slicedToArray2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

  _slicedToArray2 = function _slicedToArray2() {
    return data;
  };

  return data;
}

function _asyncToGenerator2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

  _asyncToGenerator2 = function _asyncToGenerator2() {
    return data;
  };

  return data;
}

function _lockfile() {
  var data = _interopRequireDefault(require("../../lockfile"));

  _lockfile = function _lockfile() {
    return data;
  };

  return data;
}

function _install() {
  var data = require("./install.js");

  _install = function _install() {
    return data;
  };

  return data;
}

function _errors() {
  var data = require("../../errors.js");

  _errors = function _errors() {
    return data;
  };

  return data;
}

function fs() {
  var data = _interopRequireWildcard(require("../../util/fs.js"));

  fs = function fs() {
    return data;
  };

  return data;
}

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

var path = require('path');

function hasWrapper(commander) {
  return true;
}

function setFlags(commander) {
  commander.description('Temporarily copies a package (with an optional @range suffix) outside of the global cache for debugging purposes');
  commander.usage('unplug [packages ...] [flags]');
  commander.option('--clear', 'Delete the selected packages');
  commander.option('--clear-all', 'Delete all unplugged packages');
}

function run(_x, _x2, _x3, _x4) {
  return _run.apply(this, arguments);
}

function _run() {
  _run = (0, _asyncToGenerator2()["default"])( /*#__PURE__*/_regenerator()["default"].mark(function _callee2(config, reporter, flags, args) {
    var lockfile, unpluggedPackageFolders, _iterator, _step, target;

    return _regenerator()["default"].wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            if (config.plugnplayEnabled) {
              _context2.next = 2;
              break;
            }

            throw new (_errors().MessageError)(reporter.lang('unplugDisabled'));

          case 2:
            if (!(!args.length && flags.clear)) {
              _context2.next = 4;
              break;
            }

            throw new (_errors().MessageError)(reporter.lang('tooFewArguments', 1));

          case 4:
            if (!(args.length && flags.clearAll)) {
              _context2.next = 6;
              break;
            }

            throw new (_errors().MessageError)(reporter.lang('noArguments'));

          case 6:
            if (!flags.clearAll) {
              _context2.next = 11;
              break;
            }

            _context2.next = 9;
            return clearAll(config);

          case 9:
            _context2.next = 22;
            break;

          case 11:
            if (!flags.clear) {
              _context2.next = 16;
              break;
            }

            _context2.next = 14;
            return clearSome(config, new Set(args));

          case 14:
            _context2.next = 22;
            break;

          case 16:
            if (!(args.length > 0)) {
              _context2.next = 22;
              break;
            }

            _context2.next = 19;
            return _lockfile()["default"].fromDirectory(config.lockfileFolder, reporter);

          case 19:
            lockfile = _context2.sent;
            _context2.next = 22;
            return (0, _install().wrapLifecycle)(config, flags, /*#__PURE__*/(0, _asyncToGenerator2()["default"])( /*#__PURE__*/_regenerator()["default"].mark(function _callee() {
              var install;
              return _regenerator()["default"].wrap(function _callee$(_context) {
                while (1) {
                  switch (_context.prev = _context.next) {
                    case 0:
                      install = new (_install().Install)(flags, config, reporter, lockfile);
                      install.linker.unplugged = args;
                      _context.next = 4;
                      return install.init();

                    case 4:
                    case "end":
                      return _context.stop();
                  }
                }
              }, _callee);
            })));

          case 22:
            _context2.next = 24;
            return config.listUnpluggedPackageFolders();

          case 24:
            unpluggedPackageFolders = _context2.sent;
            _iterator = _createForOfIteratorHelper(unpluggedPackageFolders.values());

            try {
              for (_iterator.s(); !(_step = _iterator.n()).done;) {
                target = _step.value;
                reporter.log(target, {
                  force: true
                });
              }
            } catch (err) {
              _iterator.e(err);
            } finally {
              _iterator.f();
            }

          case 27:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));
  return _run.apply(this, arguments);
}

function clearSome(_x5, _x6) {
  return _clearSome.apply(this, arguments);
}

function _clearSome() {
  _clearSome = (0, _asyncToGenerator2()["default"])( /*#__PURE__*/_regenerator()["default"].mark(function _callee3(config, filters) {
    var unpluggedPackageFolders, removeList, _iterator2, _step2, _step2$value, unpluggedName, target, _yield$fs$readJson, name, toBeRemoved, _iterator3, _step3, unpluggedPackagePath;

    return _regenerator()["default"].wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            _context3.next = 2;
            return config.listUnpluggedPackageFolders();

          case 2:
            unpluggedPackageFolders = _context3.sent;
            removeList = [];
            _iterator2 = _createForOfIteratorHelper(unpluggedPackageFolders.entries());
            _context3.prev = 5;

            _iterator2.s();

          case 7:
            if ((_step2 = _iterator2.n()).done) {
              _context3.next = 17;
              break;
            }

            _step2$value = (0, _slicedToArray2()["default"])(_step2.value, 2), unpluggedName = _step2$value[0], target = _step2$value[1];
            _context3.next = 11;
            return fs().readJson(path.join(target, 'package.json'));

          case 11:
            _yield$fs$readJson = _context3.sent;
            name = _yield$fs$readJson.name;
            toBeRemoved = filters.has(name);

            if (toBeRemoved) {
              removeList.push(path.join(config.getUnpluggedPath(), unpluggedName));
            }

          case 15:
            _context3.next = 7;
            break;

          case 17:
            _context3.next = 22;
            break;

          case 19:
            _context3.prev = 19;
            _context3.t0 = _context3["catch"](5);

            _iterator2.e(_context3.t0);

          case 22:
            _context3.prev = 22;

            _iterator2.f();

            return _context3.finish(22);

          case 25:
            if (!(removeList.length === unpluggedPackageFolders.size)) {
              _context3.next = 30;
              break;
            }

            _context3.next = 28;
            return fs().unlink(config.getUnpluggedPath());

          case 28:
            _context3.next = 47;
            break;

          case 30:
            _iterator3 = _createForOfIteratorHelper(removeList);
            _context3.prev = 31;

            _iterator3.s();

          case 33:
            if ((_step3 = _iterator3.n()).done) {
              _context3.next = 39;
              break;
            }

            unpluggedPackagePath = _step3.value;
            _context3.next = 37;
            return fs().unlink(unpluggedPackagePath);

          case 37:
            _context3.next = 33;
            break;

          case 39:
            _context3.next = 44;
            break;

          case 41:
            _context3.prev = 41;
            _context3.t1 = _context3["catch"](31);

            _iterator3.e(_context3.t1);

          case 44:
            _context3.prev = 44;

            _iterator3.f();

            return _context3.finish(44);

          case 47:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3, null, [[5, 19, 22, 25], [31, 41, 44, 47]]);
  }));
  return _clearSome.apply(this, arguments);
}

function clearAll(_x7) {
  return _clearAll.apply(this, arguments);
}

function _clearAll() {
  _clearAll = (0, _asyncToGenerator2()["default"])( /*#__PURE__*/_regenerator()["default"].mark(function _callee4(config) {
    return _regenerator()["default"].wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            _context4.next = 2;
            return fs().unlink(config.getUnpluggedPath());

          case 2:
          case "end":
            return _context4.stop();
        }
      }
    }, _callee4);
  }));
  return _clearAll.apply(this, arguments);
}
//# sourceMappingURL=unplug.js.map
