"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.buildTree = buildTree;
exports.getParent = getParent;

function _regenerator() {
  var data = _interopRequireDefault(require("@babel/runtime/regenerator"));

  _regenerator = function _regenerator() {
    return data;
  };

  return data;
}

function _slicedToArray2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

  _slicedToArray2 = function _slicedToArray2() {
    return data;
  };

  return data;
}

function _asyncToGenerator2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

  _asyncToGenerator2 = function _asyncToGenerator2() {
    return data;
  };

  return data;
}

function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

var invariant = require('invariant');

function getParent(key, treesByKey) {
  var parentKey = key.slice(0, key.lastIndexOf('#'));
  return treesByKey[parentKey];
}

function buildTree(_x, _x2, _x3, _x4) {
  return _buildTree.apply(this, arguments);
}

function _buildTree() {
  _buildTree = (0, _asyncToGenerator2()["default"])( /*#__PURE__*/_regenerator()["default"].mark(function _callee(resolver, linker, patterns, ignoreHoisted) {
    var treesByKey, trees, flatTree, workspaceLayout, hoisted, hoistedByKey, _iterator, _step, _step$value, key, info, _iterator2, _step2, _step2$value, _info, ref, children, _iterator3, _step3, _step3$value, _info2, tree, parent;

    return _regenerator()["default"].wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            treesByKey = {};
            trees = [];
            _context.next = 4;
            return linker.getFlatHoistedTree(patterns);

          case 4:
            flatTree = _context.sent;
            // If using workspaces, filter out the virtual manifest
            workspaceLayout = resolver.workspaceLayout;
            hoisted = workspaceLayout && workspaceLayout.virtualManifestName ? flatTree.filter(function (_ref) {
              var _ref2 = (0, _slicedToArray2()["default"])(_ref, 1),
                  key = _ref2[0];

              return key.indexOf(workspaceLayout.virtualManifestName) === -1;
            }) : flatTree;
            hoistedByKey = {};
            _iterator = _createForOfIteratorHelper(hoisted);

            try {
              for (_iterator.s(); !(_step = _iterator.n()).done;) {
                _step$value = (0, _slicedToArray2()["default"])(_step.value, 2), key = _step$value[0], info = _step$value[1];
                hoistedByKey[key] = info;
              } // build initial trees

            } catch (err) {
              _iterator.e(err);
            } finally {
              _iterator.f();
            }

            _iterator2 = _createForOfIteratorHelper(hoisted);

            try {
              for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
                _step2$value = (0, _slicedToArray2()["default"])(_step2.value, 2), _info = _step2$value[1];
                ref = _info.pkg._reference; // const parent = getParent(info.key, treesByKey);

                children = []; // let depth = 0;

                invariant(ref, 'expected reference'); // check parent to obtain next depth
                // if (parent && parent.depth > 0) {
                //   depth = parent.depth + 1;
                // } else {
                //   depth = 0;
                // }

                treesByKey[_info.key] = {
                  name: _info.pkg.name,
                  version: _info.pkg.version,
                  children: children,
                  manifest: _info
                };
              } // add children

            } catch (err) {
              _iterator2.e(err);
            } finally {
              _iterator2.f();
            }

            _iterator3 = _createForOfIteratorHelper(hoisted);
            _context.prev = 13;

            _iterator3.s();

          case 15:
            if ((_step3 = _iterator3.n()).done) {
              _context.next = 27;
              break;
            }

            _step3$value = (0, _slicedToArray2()["default"])(_step3.value, 2), _info2 = _step3$value[1];
            tree = treesByKey[_info2.key];
            parent = getParent(_info2.key, treesByKey);

            if (tree) {
              _context.next = 21;
              break;
            }

            return _context.abrupt("continue", 25);

          case 21:
            if (!(_info2.key.split('#').length === 1)) {
              _context.next = 24;
              break;
            }

            trees.push(tree);
            return _context.abrupt("continue", 25);

          case 24:
            if (parent) {
              parent.children.push(tree);
            }

          case 25:
            _context.next = 15;
            break;

          case 27:
            _context.next = 32;
            break;

          case 29:
            _context.prev = 29;
            _context.t0 = _context["catch"](13);

            _iterator3.e(_context.t0);

          case 32:
            _context.prev = 32;

            _iterator3.f();

            return _context.finish(32);

          case 35:
            return _context.abrupt("return", trees);

          case 36:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, null, [[13, 29, 32, 35]]);
  }));
  return _buildTree.apply(this, arguments);
}
//# sourceMappingURL=hoisted-tree-builder.js.map
