"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
exports.explodeEntry = explodeEntry;
exports.implodeEntry = implodeEntry;
Object.defineProperty(exports, "parse", {
  enumerable: true,
  get: function get() {
    return _parse2()["default"];
  }
});
Object.defineProperty(exports, "stringify", {
  enumerable: true,
  get: function get() {
    return _stringify()["default"];
  }
});

function _regenerator() {
  var data = _interopRequireDefault(require("@babel/runtime/regenerator"));

  _regenerator = function _regenerator() {
    return data;
  };

  return data;
}

function _asyncToGenerator2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

  _asyncToGenerator2 = function _asyncToGenerator2() {
    return data;
  };

  return data;
}

function _classCallCheck2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

  _classCallCheck2 = function _classCallCheck2() {
    return data;
  };

  return data;
}

function _createClass2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

  _createClass2 = function _createClass2() {
    return data;
  };

  return data;
}

function _defineProperty2() {
  var data = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

  _defineProperty2 = function _defineProperty2() {
    return data;
  };

  return data;
}

function _misc() {
  var data = require("../util/misc.js");

  _misc = function _misc() {
    return data;
  };

  return data;
}

function _normalizePattern() {
  var data = require("../util/normalize-pattern.js");

  _normalizePattern = function _normalizePattern() {
    return data;
  };

  return data;
}

function _parse() {
  var data = _interopRequireDefault(require("./parse.js"));

  _parse = function _parse() {
    return data;
  };

  return data;
}

function _constants() {
  var data = require("../constants.js");

  _constants = function _constants() {
    return data;
  };

  return data;
}

function fs() {
  var data = _interopRequireWildcard(require("../util/fs.js"));

  fs = function fs() {
    return data;
  };

  return data;
}

function _parse2() {
  var data = _interopRequireDefault(require("./parse"));

  _parse2 = function _parse2() {
    return data;
  };

  return data;
}

function _stringify() {
  var data = _interopRequireDefault(require("./stringify"));

  _stringify = function _stringify() {
    return data;
  };

  return data;
}

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

var invariant = require('invariant');

var path = require('path');

var ssri = require('ssri');

function getName(pattern) {
  return (0, _normalizePattern().normalizePattern)(pattern).name;
}

function blankObjectUndefined(obj) {
  return obj && Object.keys(obj).length ? obj : undefined;
}

function keyForRemote(remote) {
  return remote.resolved || (remote.reference && remote.hash ? "".concat(remote.reference, "#").concat(remote.hash) : null);
}

function serializeIntegrity(integrity) {
  // We need this because `Integrity.toString()` does not use sorting to ensure a stable string output
  // See https://git.io/vx2Hy
  return integrity.toString().split(' ').sort().join(' ');
}

function implodeEntry(pattern, obj) {
  var inferredName = getName(pattern);
  var integrity = obj.integrity ? serializeIntegrity(obj.integrity) : '';
  var imploded = {
    name: inferredName === obj.name ? undefined : obj.name,
    version: obj.version,
    uid: obj.uid === obj.version ? undefined : obj.uid,
    resolved: obj.resolved,
    registry: obj.registry === 'npm' ? undefined : obj.registry,
    dependencies: blankObjectUndefined(obj.dependencies),
    optionalDependencies: blankObjectUndefined(obj.optionalDependencies),
    permissions: blankObjectUndefined(obj.permissions),
    prebuiltVariants: blankObjectUndefined(obj.prebuiltVariants)
  };

  if (integrity) {
    imploded.integrity = integrity;
  }

  return imploded;
}

function explodeEntry(pattern, obj) {
  obj.optionalDependencies = obj.optionalDependencies || {};
  obj.dependencies = obj.dependencies || {};
  obj.uid = obj.uid || obj.version;
  obj.permissions = obj.permissions || {};
  obj.registry = obj.registry || 'npm';
  obj.name = obj.name || getName(pattern);
  var integrity = obj.integrity;

  if (integrity && integrity.isIntegrity) {
    obj.integrity = ssri.parse(integrity);
  }

  return obj;
}

var Lockfile = /*#__PURE__*/function () {
  function Lockfile() {
    var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
        cache = _ref.cache,
        source = _ref.source,
        parseResultType = _ref.parseResultType;

    (0, _classCallCheck2()["default"])(this, Lockfile);
    (0, _defineProperty2()["default"])(this, "source", void 0);
    (0, _defineProperty2()["default"])(this, "cache", void 0);
    (0, _defineProperty2()["default"])(this, "parseResultType", void 0);
    this.source = source || '';
    this.cache = cache;
    this.parseResultType = parseResultType;
  } // source string if the `cache` was parsed


  (0, _createClass2()["default"])(Lockfile, [{
    key: "hasEntriesExistWithoutIntegrity",
    value: // if true, we're parsing an old yarn file and need to update integrity fields
    function hasEntriesExistWithoutIntegrity() {
      if (!this.cache) {
        return false;
      }

      for (var _key in this.cache) {
        // $FlowFixMe - `this.cache` is clearly defined at this point
        if (!/^.*@(file:|http)/.test(_key) && this.cache[_key] && !this.cache[_key].integrity) {
          return true;
        }
      }

      return false;
    }
  }, {
    key: "getLocked",
    value: function getLocked(pattern) {
      var cache = this.cache;

      if (!cache) {
        return undefined;
      }

      var shrunk = pattern in cache && cache[pattern];

      if (typeof shrunk === 'string') {
        return this.getLocked(shrunk);
      } else if (shrunk) {
        explodeEntry(pattern, shrunk);
        return shrunk;
      }

      return undefined;
    }
  }, {
    key: "removePattern",
    value: function removePattern(pattern) {
      var cache = this.cache;

      if (!cache) {
        return;
      }

      delete cache[pattern];
    }
  }, {
    key: "getLockfile",
    value: function getLockfile(patterns) {
      var lockfile = {};
      var seen = new Map(); // order by name so that lockfile manifest is assigned to the first dependency with this manifest
      // the others that have the same remoteKey will just refer to the first
      // ordering allows for consistency in lockfile when it is serialized

      var sortedPatternsKeys = Object.keys(patterns).sort(_misc().sortAlpha);

      var _iterator = _createForOfIteratorHelper(sortedPatternsKeys),
          _step;

      try {
        for (_iterator.s(); !(_step = _iterator.n()).done;) {
          var pattern = _step.value;
          var pkg = patterns[pattern];
          var remote = pkg._remote,
              ref = pkg._reference;
          invariant(ref, 'Package is missing a reference');
          invariant(remote, 'Package is missing a remote');
          var remoteKey = keyForRemote(remote);
          var seenPattern = remoteKey && seen.get(remoteKey);

          if (seenPattern) {
            // no point in duplicating it
            lockfile[pattern] = seenPattern; // if we're relying on our name being inferred and two of the patterns have
            // different inferred names then we need to set it

            if (!seenPattern.name && getName(pattern) !== pkg.name) {
              seenPattern.name = pkg.name;
            }

            continue;
          }

          var obj = implodeEntry(pattern, {
            name: pkg.name,
            version: pkg.version,
            uid: pkg._uid,
            resolved: remote.resolved,
            integrity: remote.integrity,
            registry: remote.registry,
            dependencies: pkg.dependencies,
            peerDependencies: pkg.peerDependencies,
            optionalDependencies: pkg.optionalDependencies,
            permissions: ref.permissions,
            prebuiltVariants: pkg.prebuiltVariants
          });
          lockfile[pattern] = obj;

          if (remoteKey) {
            seen.set(remoteKey, obj);
          }
        }
      } catch (err) {
        _iterator.e(err);
      } finally {
        _iterator.f();
      }

      return lockfile;
    }
  }], [{
    key: "fromDirectory",
    value: function () {
      var _fromDirectory = (0, _asyncToGenerator2()["default"])( /*#__PURE__*/_regenerator()["default"].mark(function _callee(dir, reporter) {
        var lockfileLoc, lockfile, rawLockfile, parseResult, lockfilev2;
        return _regenerator()["default"].wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                // read the manifest in this directory
                lockfileLoc = path.join(dir, _constants().LOCKFILE_FILENAME);
                rawLockfile = '';
                _context.next = 4;
                return fs().exists(lockfileLoc);

              case 4:
                if (!_context.sent) {
                  _context.next = 13;
                  break;
                }

                _context.next = 7;
                return fs().readFile(lockfileLoc);

              case 7:
                rawLockfile = _context.sent;
                parseResult = (0, _parse()["default"])(rawLockfile, lockfileLoc);

                if (reporter) {
                  if (parseResult.type === 'merge') {
                    reporter.info(reporter.lang('lockfileMerged'));
                  } else if (parseResult.type === 'conflict') {
                    reporter.warn(reporter.lang('lockfileConflict'));
                  }
                }

                lockfile = parseResult.object;
                _context.next = 14;
                break;

              case 13:
                if (reporter) {
                  reporter.info(reporter.lang('noLockfileFound'));
                }

              case 14:
                if (lockfile && lockfile.__metadata) {
                  lockfilev2 = lockfile;
                  lockfile = {};
                }

                return _context.abrupt("return", new Lockfile({
                  cache: lockfile,
                  source: rawLockfile,
                  parseResultType: parseResult && parseResult.type
                }));

              case 16:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      function fromDirectory(_x, _x2) {
        return _fromDirectory.apply(this, arguments);
      }

      return fromDirectory;
    }()
  }]);
  return Lockfile;
}();

exports["default"] = Lockfile;
//# sourceMappingURL=index.js.map
